##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/brw_hook.4gl  1.1  Last Delta: 10/26/88
##############################################################################

#######################################################################
function brw_hook(ring_rowid, ring_cursor, ring_total)
# returning false, ring_rowid, ring_cursor, ring_total
#######################################################################
#  if this function is called, that means that there is no local
#  brw_hook(), and don't link in the scrolling library.
#
	define
		ring_rowid	smallint,		# rowid of current selection
		ring_cursor smallint,		# absolute cursor address
        ring_total  integer,
		scratch		char(40)

    menu " Browse"
        command "First  " " Move to first selected document"
            call ring_view(1) returning ring_rowid, ring_cursor
            call ring_border(ring_rowid, ring_cursor, ring_total)
        command "Last  " " Move to last selected document"
            call ring_view(ring_total) returning ring_rowid, ring_cursor
            call ring_border(ring_rowid, ring_cursor, ring_total)
        command key (n,F3)
            "Next  " " Move to next document"
            if ring_total = 0
            then
                continue menu
            end if
            if ring_cursor = ring_total
            then
                let ring_cursor = 0
            end if
            let ring_cursor = ring_cursor + 1
            call ring_view(ring_cursor) returning ring_rowid, ring_cursor
            call ring_border(ring_rowid, ring_cursor, ring_total)
        command key (p,F4)
            "Prev  " " Move to previous document"
            if ring_total = 0
            then
                continue menu
            end if
            if ring_cursor <= 1
            then
                let ring_cursor = ring_total + 1
            end if
            let ring_cursor = ring_cursor - 1
            call ring_view(ring_cursor) returning ring_rowid, ring_cursor
            call ring_border(ring_rowid, ring_cursor, ring_total)
        command "Goto  " " Move to specified document"
            call ring_clear()
			let scratch = "Goto:  [1-",ring_total using "<<<<<" clipped,
				"]  or  [DEL] to Quit"
			display scratch at 1,2
            let status = 1
            let int_flag = 0
            whenever error continue
            while status != 0 and int_flag = 0
                let status = 0
                prompt " Move to the document in position: " for ring_rowid
            end while
            whenever error call error_handler
			if int_flag != 0
			then
				let int_flag = 0
				continue menu
			end if
            if ring_rowid >= 1 and ring_rowid <= ring_total
            then
                call ring_view(ring_rowid) returning ring_rowid, ring_cursor
            else
            	if ring_rowid < 1
				then
                	call ring_view(1) returning ring_rowid, ring_cursor
				end if
				if ring_rowid > ring_total
				then
                	call ring_view(ring_total) returning ring_rowid, ring_cursor
				end if
            end if
            call ring_border(ring_rowid, ring_cursor, ring_total)
        command key (e,x,q,"interrupt")
            "Quit" " Return to previous menu"
            exit menu
        command key ("!")
            call ring_bang()
    end menu
	# false return telling r_browse that the window browser wasn't used.
    return false, ring_rowid, ring_cursor, ring_total
end function
# brw_hook()
