##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_delete.4gl  1.2  Last Delta: 9/4/90
##############################################################################

#######################################################################
function ring_delete(ring_rowid)
#   returning ring_rowid
#######################################################################
#
    define
        ring_rowid  integer,
        yesno       char(1)

    if ring_rowid = 0
    then
		call fg_error("r_menu","r_delete",1)
        return ring_rowid
    end if

    if ring_rowid < 0
    then
		call fg_error("r_menu","r_delete",2)
        return ring_rowid
    end if

	# intelligent deletion routine
	if ok_delete()
	then
		# no op
	else
		return ring_rowid
	end if

    call ring_clear()
	let int_flag = 0
    display "Delete:  Verify document deletion" at 1,2
    prompt " Erase this document? (Y/N) " for char yesno
    if yesno matches "[yY]" and int_flag = 0
    then
        # no-op
    else
		let int_flag = 0
        return ring_rowid
    end if

    # read, and lock the record
    call mlh_lock(ring_rowid)
    if sqlca.sqlcode != 0
    then
        if sqlca.sqlcode = notfound
        then
			# somebody has already deleted it.
            clear form
            let ring_rowid = -1
        else
			call fg_error("r_menu","r_delete",3)
        end if
        let sqlca.sqlcode = 0
        return ring_rowid
    end if

    call lld_delete()
    call llh_delete(ring_rowid)
    call mlh_unlock()
    clear form
    return -1
end function
# ring_delete()
