##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_find.4gl  1.2  Last Delta: 9/4/90
##############################################################################

#######################################################################
function ring_find(ring_rowid,ring_cursor,ring_total)
#   returning ring_rowid, ring_cursor, ring_total
#######################################################################
#   - this is run when "find" is selected
#   - if successful, the first row is displayed
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
		criteria	char(256)	# construct criteria

	# intelligent find routine
	if ok_find()
	then
		# no op
	else
		return ring_rowid, ring_cursor, ring_total
	end if

	call ring_clear()
	display "Find:  [ESC] to Find  [DEL] to Cancel" at 1,2
	display "Enter selection criteria into form" at 2,2

	clear form
	let int_flag = 0

    # define a new cursor
	call mlh_construct() returning criteria
	if int_flag != 0
    then
        # decided against "find" command
        clear form
        let int_flag = 0
        call ring_view(ring_cursor) returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if

    # close the cursor if open.
    if ring_total > 0
    then
        call mlh_close_cur()
    end if

	# define the cursor/present the first record
	call ring_define(criteria)
		returning ring_rowid, ring_cursor, ring_total

    return ring_rowid, ring_cursor, ring_total
end function
# ring_find()



#######################################################################
function ring_define(criteria)
# returning ring_rowid, ring_cursor, ring_total
#######################################################################
#
    define
		criteria	char(256),	# construct criteria
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer

	call please_wait()
    call mlh_define_cur(criteria)

    # error if bad status, interrupt, or no rows processed
    if sqlca.sqlcode !=0 or int_flag != 0 or sqlca.sqlerrd[3] = 0
    then
        clear form
        let sqlca.sqlcode = 0
        let int_flag = 0
        let ring_rowid = -1
        let ring_total = 0
        let ring_cursor = 0
        return ring_rowid, ring_cursor, ring_total
    end if

    # cursor defined ok.
    let ring_total = sqlca.sqlerrd[3]

    # grab the first row of the cursor
    call ring_view(1) returning ring_rowid, ring_cursor

    return ring_rowid, ring_cursor, ring_total
end function
# ring_define()
