##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_scroll.4gl  1.3  Last Delta: 9/4/90
##############################################################################

#######################################################################
function ring_scroll(ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
#######################################################################
#   scrolling browser
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
        num_rows    smallint,
        win_width   smallint,
        win_length  smallint,
		curr_line	smallint,		# current line number
		cur_hold	integer,		# holding bin for the current cursor
        quit_flag   smallint,       # indicator to go back w/o selecting
        scratch     char(40)

	call brw_open() returning num_rows
	let cur_hold = ring_cursor
	let curr_line = 1

    display
        "========================================",
        "========================================"
        at 3,1 attribute(white)

    # calculate window dimentions:
    whenever error continue
    for win_length = 24 to 1 step -1
        let status = 0
        display "" at win_length, 1
        if status = 0
        then
            exit for
        end if
    end for
    for win_width = 80 to 1 step -1
        let status = 0
        display "" at win_length, win_width
        if status = 0
        then
            exit for
        end if
    end for
    whenever error call error_handler

	call ring_draw_win(num_rows, ring_cursor, ring_total)

	call ring_highlight(curr_line, ring_cursor)
		returning ring_rowid

    call ring_brw_border(win_width, win_length,
                        ring_rowid, ring_cursor, ring_total)

	let int_flag = 0
    let quit_flag = 0
    menu " Browse"
        command "Next" " Move to next document"
            if ring_cursor = ring_total
            then
				error ""
                continue menu
            end if

			# unlight current highligted item
			call brw_display(curr_line,false)

			let ring_cursor = ring_cursor + 1
			if curr_line = num_rows
			then # page down
				let curr_line = 1
				call ring_draw_win(num_rows, ring_cursor, ring_total)
			else
				let curr_line = curr_line + 1
			end if
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                       	ring_rowid, ring_cursor, ring_total)
        command "Prev" " Move to previous document"
            if ring_cursor = 1
            then
				error ""
                continue menu
            end if

			# unlight current highligted item
			call brw_display(curr_line,false)

			let ring_cursor = ring_cursor - 1
			if curr_line = 1
			then # page up
				if (ring_cursor - num_rows + 1) <= 1
				then # go to top
					let curr_line = ring_cursor
					let ring_cursor = 1
					call ring_draw_win(num_rows, ring_cursor, ring_total)
					let ring_cursor = curr_line
				else
					let curr_line = num_rows
					let ring_cursor = ring_cursor - num_rows + 1
					call ring_draw_win(num_rows, ring_cursor, ring_total)
					let ring_cursor = ring_cursor + num_rows - 1
				end if
			else
				let curr_line = curr_line - 1
			end if
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                       	ring_rowid, ring_cursor, ring_total)
        command key (F3,u)
            "Up" " Move up one page"
            if ring_cursor = 1
            then
				error ""
                continue menu
            end if

			# unlight current highligted item
			call brw_display(curr_line,false)

			if (ring_cursor - num_rows - curr_line + 1) < 1
			then # go to top
				let curr_line = 1
				let ring_cursor = 1
				call ring_draw_win(num_rows, ring_cursor, ring_total)
			else
				let ring_cursor = ring_cursor - num_rows - curr_line + 1
				call ring_draw_win(num_rows, ring_cursor, ring_total)
				let ring_cursor = ring_cursor + curr_line - 1
			end if
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                       	ring_rowid, ring_cursor, ring_total)
        command key (F4,d)
            "Down" " Move down one page"
            if ring_cursor = ring_total
            then
				error ""
                continue menu
            end if

			# unlight current highligted item
			call brw_display(curr_line,false)

			if (ring_cursor + num_rows) > ring_total
			then # go to bottom
				if num_rows <= ring_total
				then
					let curr_line = num_rows
					let ring_cursor = ring_total - num_rows + 1
					call ring_draw_win(num_rows, ring_cursor, ring_total)
					let ring_cursor = ring_total
				else
					let curr_line = ring_total
					let ring_cursor = 1
					call ring_draw_win(num_rows, ring_cursor, ring_total)
					let ring_cursor = ring_total
				end if
			else # just page down
				let ring_cursor = ring_cursor + num_rows - curr_line + 1
				call ring_draw_win(num_rows, ring_cursor, ring_total)
				let ring_cursor = ring_cursor + curr_line - 1
			end if
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                       	ring_rowid, ring_cursor, ring_total)
        command "Top" " Move to first selected document"
			let curr_line = 1
			let ring_cursor = 1
			call ring_draw_win(num_rows, ring_cursor, ring_total)
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                        ring_rowid, ring_cursor, ring_total)
        command "Bottom" " Move to last selected document"
			if num_rows <= ring_total
			then
				let curr_line = num_rows
				let ring_cursor = ring_total - num_rows + 1
				call ring_draw_win(num_rows, ring_cursor, ring_total)
				let ring_cursor = ring_total
			else
				let curr_line = ring_total
				let ring_cursor = 1
				call ring_draw_win(num_rows, ring_cursor, ring_total)
				let ring_cursor = ring_total
			end if
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                     ring_rowid, ring_cursor, ring_total)
        command "Goto" " Move to specified document"
            call ring_clear()
            let scratch = "Goto:  [1-",ring_total using "<<<<<" clipped,
                "]  or  [DEL] to Quit"
            display scratch at 1,2
            let status = 1
            let int_flag = 0
            whenever error continue
            while status != 0 and int_flag = 0
                let status = 0
                prompt " Move to the document in position: " for ring_rowid
            end while
            whenever error call error_handler
            if int_flag != 0 or status != 0
            then
                let int_flag = 0
                continue menu
            end if
            if ring_rowid >= 1 and ring_rowid <= ring_total
            then
				let ring_cursor = ring_rowid
            else
                if ring_rowid < 1
                then
				    let ring_cursor = 1
                end if
                if ring_rowid > ring_total
                then
					let ring_cursor = ring_total
                end if
            end if
			let curr_line = 1
			call ring_draw_win(num_rows, ring_cursor, ring_total)
			call ring_highlight(curr_line, ring_cursor)
				returning ring_rowid
    		call ring_brw_border(win_width, win_length,
                       	ring_rowid, ring_cursor, ring_total)
        command key (s,"escape")
            "Select" " Choose this document"
            exit menu
        command key (q,e,x,"interrupt")
            "Quit" " Return without selecting a document"
            let quit_flag = 1
            exit menu
        command key ("!")
            call ring_bang()
    end menu
    call brw_close()
	# display the last highligted item
	if quit_flag != 0
	then
		let ring_cursor = cur_hold
		let int_flag = 0
	end if
	call ring_view(ring_cursor)
		returning ring_rowid, ring_cursor
    return ring_rowid, ring_cursor, ring_total
end function
# ring_scroll()

#######################################################################
function ring_brw_border(win_width,
    win_length, ring_rowid, ring_cursor, ring_total)
#######################################################################
#   browser border
#
    define
        win_width   smallint,
        win_length  smallint,
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
        scr_pos     smallint,
        scratch     char(40)

    let scratch = "(",ring_cursor using "<<<<<" clipped," of ",
                    ring_total using "<<<<<" clipped,")"

    if ring_rowid = 0
    then
            let scratch = scratch clipped," (Deleted)"
    end if

    let scr_pos = (win_width / 2) - (length(scratch) / 2)

    display "" at win_length, 1
    display scratch at win_length, scr_pos attribute(white)

end function
# ring_brw_border()

#######################################################################
function ring_draw_win(num_rows, ring_cursor, ring_total)
#######################################################################
#   draw a whole window
#
    define
        num_rows    smallint,
        ring_cursor integer,
        ring_total  integer,
		ring_rowid	integer,
        n		    smallint

	for n = 1 to num_rows
		call mlh_clear()
		if (ring_cursor + n - 1) <= ring_total
		then
			call ring_fetch(ring_cursor + n - 1)
				returning ring_rowid
		end if
		call brw_display(n, false)
	end for

	return
end function
# ring_draw_win()

#######################################################################
function ring_fetch(ring_cursor)
# returning ring_rowid
#######################################################################
#   - this function works with an open cursor.  it fetches the
#     element specified by the argument. into the p_variables
#

    define
        ring_cursor integer,    # proposed cursor number
		ring_rowid	integer		# rowid

    let int_flag = 0
    call mlh_clear()                # clear out all elements in header
    call mlh_fetch_cur(ring_cursor) # fetch rowid into sqlca.sqlerrd[6]
    let ring_rowid = sqlca.sqlerrd[6]
    call llh_read(ring_rowid)       # get the record into the m_* variables
									# and into the p_* variables
    if sqlca.sqlcode != 0 or int_flag != 0
    then
	call mlh_clear()
        let sqlca.sqlcode = 0
        let int_flag = 0
        return -1
    end if
    return ring_rowid
end function
# ring_fetch()

#######################################################################
function ring_highlight (curr_line, ring_cursor)
# returning ring_rowid
#######################################################################
#   - this function works with an open cursor.  it fetches the
#     element specified by the argument into the p_variables
#	  then displays it highlighted
#

    define
		curr_line	smallint,   # current line number to highlight
        ring_cursor integer,    # proposed cursor number
		ring_rowid	integer		# return value

	call ring_fetch(ring_cursor)
		returning ring_rowid

	call brw_display(curr_line,true)
	return ring_rowid
end function
# ring_highlight()
