#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_update.4gl  1.3  Delta: 9/4/90
#####################################################################

#######################################################################
function ring_update(lab_type, ring_rowid)
#######################################################################
#
    define
		lab_type 	integer,
        ring_rowid  integer

    if ring_rowid = 0
    then
		call fg_error("r_menu","r_update",1)
        return
    end if

    if ring_rowid < 0
    then
		call fg_error("r_menu","r_update",2)
        return
    end if

	# intelligent update routine
	if ok_update()
	then
		# no op
	else
		return
	end if

	call ring_clear()
	display "Update:  [ESC] to Store  [DEL] to Cancel" at 1,2
	if lab_type = 2
	then
		display "[TAB] Next Window" at 1,44
	end if
	display "Enter changes into form" at 2,2
    call dsp_help()

    # read, and lock the record
    call mlh_lock(ring_rowid)
    if sqlca.sqlcode != 0
    then
        if sqlca.sqlcode = notfound
        then
			call fg_error("r_menu","r_update",3)
        else
			call fg_error("r_menu","r_update",4)
        end if
        let sqlca.sqlcode = 0
        return
    end if
    let int_flag = 0

    # record is now locked. call screen input function
    if ring_input() = -1
    then
        call ring_restore(ring_rowid)
        return
    end if

	# call the generic update function that can be called from the options
	# menu also.
	call ring_llupdate(ring_rowid)

	# unlock the record
    call mlh_unlock()
    return
end function
# ring_update()

#######################################################################
function ring_restore(ring_rowid)
#######################################################################
    define
        ring_rowid  integer
    message " Restoring document..."
    clear form
	call mlh_clear()			  # clear out the header records
	call mld_clear()			  # clear out the detail arrays
    call llh_read(ring_rowid)     # restore the header data
    call lld_read()               # restore the detail data
    call llh_display()            # write header to the screen
    call lld_display()            # write detail to the screen
    call mlh_unlock()             # unlock the header record
    let int_flag = 0
    sleep 1
    return
end function
# ring_restore()
